diff --git a/assembler/Makefile.am b/assembler/Makefile.am
index fb309ac..bed6c07 100644
--- a/assembler/Makefile.am
+++ b/assembler/Makefile.am
@@ -47,8 +47,112 @@ intel_gen4disasm_LDADD = libbrw.la
 pkgconfigdir = $(libdir)/pkgconfig
 pkgconfig_DATA = intel-gen4asm.pc
 
-CLEANFILES = $(BUILT_SOURCES)
+check_SCRIPTS = test/run-test.sh
+
+TESTS = \
+	test/mov \
+	test/frc \
+	test/rndd \
+	test/rndu \
+	test/rnde \
+	test/rnde-intsrc \
+	test/rndz \
+	test/lzd \
+	test/not \
+	test/immediate \
+	$(NULL)
+
+# Tests that are expected to fail because they contain some inccorect code.
+XFAIL_TESTS =
+
+# Those tests were already failing when the assembler was imported from
+# the intel-gen4asm git repository:
+#   http://cgit.freedesktop.org/xorg/app/intel-gen4asm/
+# We disable them "for now" as a workaround to be able to release i-g-t
+disabled_tests = \
+	test/declare \
+	test/jmpi \
+	test/if \
+	test/iff \
+	test/while \
+	test/else \
+	test/break \
+	test/cont \
+	test/halt \
+	test/wait \
+	test/endif \
+	$(NULL)
+
+disabled_xfail_tests = \
+	test/rnde-intsrc \
+	$(NULL)
+
+TESTDATA = \
+	test/mov.expected \
+	test/mov.g4a \
+	test/frc.expected \
+	test/frc.g4a \
+	test/rndd.expected \
+	test/rndd.g4a \
+	test/rndu.expected \
+	test/rndu.g4a \
+	test/rnde.expected \
+	test/rnde.g4a \
+	test/rnde-intsrc.expected \
+	test/rnde-intsrc.g4a \
+	test/rndz.expected \
+	test/rndz.g4a \
+	test/lzd.expected \
+	test/lzd.g4a \
+	test/not.expected \
+	test/not.g4a \
+	test/jmpi.expected \
+	test/jmpi.g4a \
+	test/if.expected \
+	test/if.g4a \
+	test/iff.expected \
+	test/iff.g4a \
+	test/while.expected \
+	test/while.g4a \
+	test/else.expected \
+	test/else.g4a \
+	test/break.expected \
+	test/break.g4a \
+	test/cont.expected \
+	test/cont.g4a \
+	test/halt.expected \
+	test/halt.g4a \
+	test/wait.expected \
+	test/wait.g4a \
+	test/endif.expected \
+	test/endif.g4a \
+	test/declare.expected \
+	test/declare.g4a \
+	test/immediate.g4a \
+	test/immediate.expected \
+	$(NULL)
+
+test_EXTRA_DIST = \
+	${TESTDATA} \
+	test/run-test.sh \
+	$(NULL)
+
+$(TESTS): test/run-test.sh
+	sed "s|TEST|$@|g" ${srcdir}/test/run-test.sh > $@
+	chmod +x $@
+
+test_CLEANFILES = \
+	test/*.out \
+	${TESTS} \
+	$(NULL)
+
+CLEANFILES = $(BUILT_SOURCES) \
+	     $(test_CLEANFILES) \
+	     $(NULL)
+
 EXTRA_DIST = \
 	README \
 	TODO \
-	intel-gen4asm.pc.in
+	intel-gen4asm.pc.in \
+	$(test_EXTRA_DIST) \
+	$(NULL)
diff --git a/assembler/test/Makefile.am b/assembler/test/Makefile.am
index f113119..e69de29 100644
--- a/assembler/test/Makefile.am
+++ b/assembler/test/Makefile.am
@@ -1,93 +0,0 @@
-check_SCRIPTS = run-test.sh
-
-TESTS_ENVIRONMENT = top_builddir=${top_builddir}
-TESTS = \
-	mov \
-	frc \
-	rndd \
-	rndu \
-	rnde \
-	rnde-intsrc \
-	rndz \
-	lzd \
-	not \
-	immediate
-
-# Tests that are expected to fail because they contain some inccorect code.
-XFAIL_TESTS =
-
-# Those tests were already failing when the assembler was imported from
-# the intel-gen4asm git repository:
-#   http://cgit.freedesktop.org/xorg/app/intel-gen4asm/
-# We disable them "for now" as a workaround to be able to release i-g-t
-disabled_tests = \
-	declare \
-	jmpi \
-	if \
-	iff \
-	while \
-	else \
-	break \
-	cont \
-	halt \
-	wait \
-	endif
-
-disabled_xfail_tests = \
-	rnde-intsrc
-
-TESTDATA = \
-	mov.expected \
-	mov.g4a \
-	frc.expected \
-	frc.g4a \
-	rndd.expected \
-	rndd.g4a \
-	rndu.expected \
-	rndu.g4a \
-	rnde.expected \
-	rnde.g4a \
-	rnde-intsrc.expected \
-	rnde-intsrc.g4a \
-	rndz.expected \
-	rndz.g4a \
-	lzd.expected \
-	lzd.g4a \
-	not.expected \
-	not.g4a \
-	jmpi.expected \
-	jmpi.g4a \
-	if.expected \
-	if.g4a \
-	iff.expected \
-	iff.g4a \
-	while.expected \
-	while.g4a \
-	else.expected \
-	else.g4a \
-	break.expected \
-	break.g4a \
-	cont.expected \
-	cont.g4a \
-	halt.expected \
-	halt.g4a \
-	wait.expected \
-	wait.g4a \
-	endif.expected \
-	endif.g4a \
-	declare.expected \
-	declare.g4a \
-	immediate.g4a \
-	immediate.expected
-
-EXTRA_DIST = \
-	${TESTDATA} \
-	run-test.sh
-
-$(TESTS): run-test.sh
-	sed "s|TEST|$@|g" ${srcdir}/run-test.sh > $@
-	chmod +x $@
-
-CLEANFILES = \
-	*.out \
-	${TESTS}
diff --git a/assembler/test/run-test.sh b/assembler/test/run-test.sh
index 27c5c2d..20a408c 100644
--- a/assembler/test/run-test.sh
+++ b/assembler/test/run-test.sh
@@ -3,7 +3,7 @@
 SRCDIR=${srcdir-`pwd`}
 BUILDDIR=${top_builddir-`pwd`}
 
-${BUILDDIR}/assembler/intel-gen4asm -o TEST.out $SRCDIR/TEST.g4a
+${BUILDDIR}/intel-gen4asm -o TEST.out $SRCDIR/TEST.g4a
 if cmp TEST.out ${SRCDIR}/TEST.expected 2> /dev/null; then : ; else
   echo "Output comparison for TEST"
   diff -u ${SRCDIR}/TEST.expected TEST.out